package UI;

import java.awt.*;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;


public class WallState {
    private int frameX, frameY;

    private String source;
    private String[] lines;
    private int numRows, numColumns, w, h;
    private final int wallWidth = 5;
    private ArrayList<WallData> walls = new ArrayList<>();


    public WallState(int GAME_WIDTH, int GAME_HEIGHT) {
        frameX = GAME_WIDTH;
        frameY = GAME_HEIGHT;

        try {
            source = new String(Files.readAllBytes(Paths.get("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\maps\\map3.txt")), StandardCharsets.UTF_8);
        } catch (IOException e) {
            e.printStackTrace();
        }
        lines = source.split("\r\n|\r|\n");

        numRows = lines.length;  //number of rows
        numColumns = lines[0].trim().length();  //number of columns

        h = (frameY-30) / (numRows);   //sideY
        w = (frameX-10) / (numColumns);  //sideX
    }


    public void paintComponent(Graphics g) {
        // Draw background
        walls.clear();
        g.setColor(Color.WHITE);
        g.fillRect(0, 0, frameX, frameY);
        g.setColor(Color.black);  //colour of the walls


        int start = 10;
        int startTop = 30;
        for (int r = 0; r < numRows; r++) {
            String rowChars = lines[r];
            for (int c = 0; c < numColumns; c++) {
                if (rowChars.charAt(c)=='0') continue;

                if (c==0 && r==0 ){
                    if (rowChars.charAt(c+1)=='1') draw(g,start,startTop,w+(w/2),wallWidth);
                    if (lines[r+1].charAt(c)=='1') draw(g,start,start,wallWidth,h);
                    continue;
                }

                if (r==0){
                    if (lines[r+1].charAt(c)=='1'){
                        if (c==numColumns-1) {
                            draw(g,frameX-start-wallWidth,startTop,wallWidth,h);
                        }else{
                            draw(g,(c*w)+(w/2)+start,startTop,wallWidth,h);
                        }
                    }
                }

                if ((c<numColumns-1 && rowChars.charAt(c+1)=='1') || (c>0 && rowChars.charAt(c-1)=='1')){ //horizontal
                    int y = (r*h) + startTop;
                    int x = start;
                    if (r == numRows -1)
                        y = frameY - start - wallWidth;//last row
                    if (r<numRows-1 && r>0)
                        y += h/4;
                    if (c>0)
                        x = (w*c)+(w/2)+start;
                    if (r==numRows-1 && c>0)
                        x -=w/2;
                        draw(g,x,y,w,wallWidth);
                }

                if ((r>0 && lines[r-1].charAt(c)=='1') || (r>0 && r<numRows-1 && lines[r+1].charAt(c)=='1')) { //vertical
                    int x = start;
                    int y = r * h +start;
                    int th = h;
                    if (c>0)
                        x = (c*w) + (w/2) + start;
                    if (r==numRows-1)
                        th += startTop*2;
                    if (c==numColumns-1)//last column
                        x = frameX - start - wallWidth;
                    draw(g,x, y, wallWidth, th);
                }

            }
        }

        //draw frame
        g.setColor(Color.WHITE);
        g.fillRect(0,frameX,frameX,startTop);
        g.fillRect(0,0,start,frameY);
        g.fillRect(frameX-start,0,start,frameY);
        g.fillRect(0,frameY-start,frameX,start);
    }

    public boolean isWall(int x,int y){
        for(WallData d : walls){
            if (d.isWall(x,y)) return true;
        }
        return false;
    }

    private void draw(Graphics g,int x,int y,int w,int h){
        walls.add(new WallData(x,y,w,h));
        g.fillRect(x,y,w,h);
    }



    public class WallData {
        int x,y,w,h;

        public WallData(int x,int y,int w,int h){
            this.x = x;
            this.y = y;
            this.h = h;
            this.w = w;
        }

        public boolean isWall (int x,int y){
            //BUG
            return (x>this.x && x<this.x+w && y>this.y && y<this.y+h);
        }
    }
}
